<template>
  <basic-container>
    <avue-crud ref="crud"
               v-model="form"
               :data="data"
               :option="option"
               :page.sync="page"
               @on-load="getList"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @refresh-change="refreshChange"
               @search-reset="searchChange"
               @search-change="searchChange">
      <template slot="menuLeft">
        <el-tooltip class="item" effect="dark" content="查找版本规则使用范围" placement="top">
          <el-button size="small"
                     plain
                     type="primary"
                     icon="el-icon-zoom-in"
                     @click="handleSearch">查看使用范围
          </el-button>
        </el-tooltip>
      </template>>
    </avue-crud>
    <el-dialog title="查看使用范围"
               append-to-body
               :visible.sync="packageSearchBox"
               width="1200px">
      <versionpackage></versionpackage>
    </el-dialog>
  </basic-container>

</template>

<script>
export default {
  name: "Version",
  data(){
    return {
      //查看使用范围
      packageSearchBox:false,
      //分页数据
      page: {
        pageSize: 10,
        currentPage: 1,
        total: 100
      },
      data:[
        {
          name:"测试1",
          tag:"测试",
          char:"测试",
          Initial:"测试",
          Step:"测试",
          prefix:"测试",
          suffix:"测试",
          desc:"测试"
        },
        {
          name:"测试2",
          tag:"测试",
          char:"测试",
          Initial:"测试",
          Step:"测试",
          prefix:"测试",
          suffix:"测试",
          desc:"测试"
        },
        {
          name:"测试3",
          tag:"测试",
          char:"测试",
          Initial:"测试",
          Step:"测试",
          prefix:"测试",
          suffix:"测试",
          desc:"测试"
        }
      ],
      form:{},
      option:{
        headerAlign:'center',
        align: 'center',
        border: true,
        index: true,
        searchMenuSpan:5,
        column:[
          {
            label:"名称",
            prop:"name",
            search:true,
          },
          {
            label: "标签",
            prop:"tag"
          },
          {
            label:"跳跃字符",
            prop:"char"
          },
          {
            label: "初始值",
            prop:"Initial"
          },
          {
            label:"步长",
            prop:"Step"
          },
          {
            label: "前缀",
            prop:"prefix"
          },
          {
            label: "后缀",
            prop: "suffix"
          },
          {
            label: "描述",
            prop:"desc",
            type:"textarea"
          }
        ]
      }
    }
  },
  methods:{
    handleSearch(){
      this.packageSearchBox=true
    },
    // getList() {
    //   this.loading = true;
    //   const data = Object.assign({
    //     pageNum: this.page.currentPage,
    //     pageSize: this.page.pageSize,
    //   }, this.params)
    //   this.data = [];
    //   getList(data).then(res => {
    //     const data = res.data.data
    //     this.loading = false;
    //     this.page.total = data.total;
    //     const result = data.list;
    //     this.data = result;
    //   })
    // },
    rowSave(row, done, loading) {
      add(Object.assign({
        createUser: this.userInfo.name
      }, row)).then(() => {
        this.$message.success('新增成功')
        done();
        this.getList();
      }).catch(() => {
        loading()
      })
    },
    rowUpdate(row, index, done, loading) {
      update(Object.assign({
        updateUser: this.userInfo.name
      }, row)).then(() => {
        this.$message.success('修改成功')
        done()
        this.getList();
      }).catch(() => {
        loading()
      })
    },
    rowDel(row) {
      this.$confirm('此操作将永久删除, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        return del(row.id)
      }).then(() => {
        this.$message.success('删除成功')
        this.getList();
      })
    },
    searchChange(params, done) {
      if (done) done();
      this.params = params;
      this.page.currentPage = 1;
      this.getList();
      this.$message.success('搜索成功')
    },
    refreshChange() {
      this.getList();
      this.$message.success('刷新成功')
    }
  }
}
</script>

<style scoped>

</style>
